% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DataClasses.R, R/functions-Chromatograms.R,
%   R/methods-Chromatograms.R
\docType{class}
\name{Chromatograms-class}
\alias{Chromatograms-class}
\alias{coerce,matrix,Chromatograms-method}
\alias{Chromatograms}
\alias{show,Chromatograms-method}
\alias{[,Chromatograms,ANY,ANY,ANY-method}
\alias{[<-,Chromatograms-method}
\alias{plot,Chromatograms,ANY-method}
\alias{phenoData,Chromatograms-method}
\alias{pData,Chromatograms-method}
\alias{pData<-,Chromatograms,data.frame-method}
\alias{$,Chromatograms-method}
\alias{$<-,Chromatograms-method}
\alias{colnames<-,Chromatograms-method}
\alias{sampleNames,Chromatograms-method}
\alias{sampleNames<-,Chromatograms,ANY-method}
\alias{isEmpty,Chromatograms-method}
\alias{featureNames,Chromatograms-method}
\alias{featureNames<-,Chromatograms-method}
\alias{featureData,Chromatograms-method}
\alias{featureData<-,Chromatograms,ANY-method}
\alias{fData,Chromatograms-method}
\alias{fData<-,Chromatograms,ANY-method}
\alias{fvarLabels,Chromatograms-method}
\alias{rownames<-,Chromatograms-method}
\alias{precursorMz,Chromatograms-method}
\alias{productMz,Chromatograms-method}
\alias{mz,Chromatograms-method}
\alias{polarity,Chromatograms-method}
\title{Container for multiple Chromatogram objects}
\usage{
Chromatograms(data, phenoData, featureData, ...)

\S4method{show}{Chromatograms}(object)

\S4method{[}{Chromatograms,ANY,ANY,ANY}(x, i, j, drop = FALSE)

\S4method{[}{Chromatograms}(x, i, j) <- value

\S4method{plot}{Chromatograms,ANY}(x, col = "#00000060", lty = 1,
  type = "l", xlab = "retention time", ylab = "intensity", main = NULL,
  ...)

\S4method{phenoData}{Chromatograms}(object)

\S4method{pData}{Chromatograms}(object)

\S4method{pData}{Chromatograms,data.frame}(object) <- value

\S4method{$}{Chromatograms}(x, name)

\S4method{$}{Chromatograms}(x, name) <- value

\S4method{colnames}{Chromatograms}(x) <- value

\S4method{sampleNames}{Chromatograms}(object)

\S4method{sampleNames}{Chromatograms,ANY}(object) <- value

\S4method{isEmpty}{Chromatograms}(x)

\S4method{featureNames}{Chromatograms}(object)

\S4method{featureNames}{Chromatograms}(object) <- value

\S4method{featureData}{Chromatograms}(object)

\S4method{featureData}{Chromatograms,ANY}(object) <- value

\S4method{fData}{Chromatograms}(object)

\S4method{fData}{Chromatograms,ANY}(object) <- value

\S4method{fvarLabels}{Chromatograms}(object)

\S4method{rownames}{Chromatograms}(x) <- value

\S4method{precursorMz}{Chromatograms}(object)

\S4method{productMz}{Chromatograms}(object)

\S4method{mz}{Chromatograms}(object)

\S4method{polarity}{Chromatograms}(object)
}
\arguments{
\item{data}{A \code{list} of \code{\link{Chromatogram}} objects.}

\item{phenoData}{either a \code{data.frame}, \code{AnnotatedDataFrame} or
\code{NAnnotatedDataFrame} describing the phenotypical information of the
samples.}

\item{featureData}{either a \code{data.frame} or \code{AnnotatedDataFrame}
with additional information for each row of chromatograms.}

\item{...}{Additional parameters to be passed to the
\code{\link[base]{matrix}} constructor, such as \code{nrow}, \code{ncol}
and \code{byrow}.}

\item{object}{a \code{Chromatograms} object.}

\item{x}{For all methods: a \code{Chromatograms} object.}

\item{i}{For \code{[}: \code{numeric}, \code{logical} or \code{character}
defining which row(s) to extract.}

\item{j}{For \code{[}: \code{numeric}, \code{logical} or \code{character}
defining which columns(s) to extract.}

\item{drop}{For \code{[}: \code{logical(1)} whether to drop the
dimensionality of the returned object (if possible). The default is
\code{drop = FALSE}, i.e. each subsetting returns a \code{Chromatograms}
object (or a \code{Chromatogram} object if a single element is
extracted).}

\item{value}{For \code{[<-}: the replacement object(s). Can be a \code{list}
    of \code{\link{Chromatogram}} objects or, if length of \code{i} and
    \code{j} are 1, a single \code{\link{Chromatogram}} object.

    For \code{pData<-}: a \code{data.frame} with the number of rows matching
    the number of columns of \code{object}.

    For \code{colnames}: a \code{character} with the new column names.}

\item{col}{For \code{plot}: the color to be used for plotting. Either a
vector of length 1 or equal to \code{ncol(x)}.}

\item{lty}{For \code{plot}: the line type (see \code{\link[graphics]{plot}}
for more details. Can be either a vector of length 1 or of length equal
to \code{ncol(x)}.}

\item{type}{For \code{plot}: the type of plot (see
\code{\link[graphics]{plot}} for more details. Can be either a vector
of length 1 or of length equal to \code{ncol(x)}.}

\item{xlab}{For \code{plot}: the x-axis label.}

\item{ylab}{For \code{plot}: the y-axis label.}

\item{main}{For \code{plot}: the plot title. If not provided the mz range
will be used as plot title.}

\item{name}{For \code{$}, the name of the pheno data column.}
}
\value{
For \code{[}: the subset of the \code{Chromatograms} object. If a
    single element is extracted (e.g. if \code{i} and \code{j} are of length
    1) a \code{\link{Chromatogram}} object is returned. Otherwise (if
    \code{drop = FALSE}, the default, is specified) a \code{Chromatograms}
    object is returned. If \code{drop = TRUE} is specified, the method
    returns a \code{list} of \code{Chromatogram} objects.

    For \code{phenoData}: an \code{NAnnotatedDataFrame} representing the
    pheno data of the object.

    For \code{pData}: a \code{data.frame} representing the pheno data of
    the object.

    For \code{$}: the value of the corresponding column in the pheno data
    table of the object.
}
\description{
The \code{Chromatograms} class allows to store
    \code{\link{Chromatogram}} objects in a \code{matrix}-like
    two-dimensional structure.

\code{Chromatograms}: create an instance of class
    \code{Chromatograms}.

\code{Chromatograms} objects can, just like a \code{matrix},
    be subsetted using the \code{[} method. Single elements, rows or columns
    can be replaced using e.g. \code{x[1, 1] <- value} where \code{value}
    has to be a \code{Chromatogram} object or a \code{list} of such objects.

\code{plot}: plots a \code{Chromatograms} object. For each row
    in the object one plot is created, i.e. all \code{\link{Chromatogram}}
    objects in the same row are added to the same plot.

\code{phenoData}: accesses the phenotypical desccription of the
    samples. Returns an \code{NAnnotatedDataFrame} object.

\code{pData}: accesses the phenotypical description of the
    samples. Returns a \code{data.frame}.

\code{pData<-}: replace the phenotype data.

\code{$} and \code{$<-}: get or replace individual columns of
    the object's pheno data.

\code{colnames<-}: replace or set the column names of the
    \code{Chromatograms} object. Does also set the \code{rownames} of the
    \code{phenoData}.

\code{sampleNames}: get the sample names.

\code{sampleNames<-}: replace or set the sample names of the
    \code{Chromatograms} object (i.e. the \code{rownames} of the pheno data
    and \code{colnames} of the data matrix.

\code{isEmpty}: returns \code{TRUE} if the \code{Chromatograms}
    object or all of its \code{Chromatogram} objects is/are empty or contain
    only \code{NA} intensities.

\code{featureNames}: returns the feature names of the
    \code{Chromatograms} object.

\code{featureNames<-}: set the feature names.

\code{featureData}: return the feature data.

\code{featureData<-}: replace the object's feature data.

\code{fData}: return the feature data as a \code{data.frame}.

\code{fData<-}: replace the object's feature data by passing a
    \code{data.frame}

\code{fvarLabels}: return the feature data variable names (i.e.
    column names).

\code{rownames<-}: replace the rownames (and featureNames) of
    the object.

\code{precursorMz}: return the precursor m/z from the chromatograms. The
method returns a \code{matrix} with 2 columns (\code{"mzmin"} and
\code{"mzmax"}) and as many rows as there are rows in the
\code{Chromatograms} object. Each row contains the precursor m/z of the
chromatograms in that row. An error is thrown if the chromatograms within one
row have different precursor m/z values.

\code{productMz}: return the product m/z from the chromatograms. The
method returns a \code{matrix} with 2 columns (\code{"mzmin"} and
\code{"mzmax"}) and as many rows as there are rows in the
\code{Chromatograms} object. Each row contains the product m/z of the
chromatograms in that row. An error is thrown if the chromatograms within one
row have different product m/z values.

\code{mz}: returns the m/z for each row of the \code{Chromatograms} object
as a two-column \code{matrix} (with columns \code{"mzmin"} and
\code{"mzmax"}).

\code{polarity}: returns the polarity of the scans/chromatograms: `1`,
`0` or `-1` for positive, negative or unknown polarity.
}
\details{
The \code{Chromatograms} class extends the base \code{matrix} class
    and hence allows to store \code{\link{Chromatogram}} objects in a
    two-dimensional array. Each row is supposed to contain
    \code{Chromatogram} objects for one MS data \emph{slice} with a common
    m/z and rt range. Columns contain \code{Chromatogram} objects from the
    same sample.

\code{plot}: if \code{nrow(x) > 1} the plot area is split into
    \code{nrow(x)} sub-plots and the chromatograms of one row are plotted in
    each.
}
\note{
Subsetting with \code{[} will always return a \code{Chromatograms}
    object (with the exception of extracting a single element)
    unless \code{drop = TRUE} is specified. This is different from the
    default subsetting behaviour of \code{matrix}-like objects.
}
\examples{
## Creating some chromatogram objects to put them into a Chromatograms object
ints <- abs(rnorm(25, sd = 200))
ch1 <- Chromatogram(rtime = 1:length(ints), ints)
ints <- abs(rnorm(32, sd = 90))
ch2 <- Chromatogram(rtime = 1:length(ints), ints)
ints <- abs(rnorm(19, sd = 120))
ch3 <- Chromatogram(rtime = 1:length(ints), ints)
ints <- abs(rnorm(21, sd = 40))
ch4 <- Chromatogram(rtime = 1:length(ints), ints)

## Create a Chromatograms object with 2 rows and 2 columns
chrs <- Chromatograms(list(ch1, ch2, ch3, ch4), nrow = 2)
chrs

## Extract the first element from the second column. Extracting a single
## element always returns a Chromatogram object.
chrs[1, 2]

## Extract the second row. Extracting a row or column (i.e. multiple elements
## returns by default a list of Chromatogram objects.
chrs[2, ]

## Extract the second row with drop = FALSE, i.e. return a Chromatograms
## object.
chrs[2, , drop = FALSE]

## Replace the first element.
chrs[1, 1] <- ch3
chrs

## Add a pheno data.
pd <- data.frame(name = c("first sample", "second sample"),
    idx = 1:2)
pData(chrs) <- pd

## Column names correspond to the row names of the pheno data
chrs

## Access a column within the pheno data
chrs$name

## Access the m/z ratio for each row; this will be NA for the present
## object
mz(chrs)

## Create some random Chromatogram objects
ints <- abs(rnorm(123, mean = 200, sd = 32))
ch1 <- Chromatogram(rtime = seq_along(ints), intensity = ints, mz = 231)
ints <- abs(rnorm(122, mean = 250, sd = 43))
ch2 <- Chromatogram(rtime = seq_along(ints), intensity = ints, mz = 231)
ints <- abs(rnorm(125, mean = 590, sd = 120))
ch3 <- Chromatogram(rtime = seq_along(ints), intensity = ints, mz = 542)
ints <- abs(rnorm(124, mean = 1200, sd = 509))
ch4 <- Chromatogram(rtime = seq_along(ints), intensity = ints, mz = 542)

## Combine into a 2x2 Chromatograms object
chrs <- Chromatograms(list(ch1, ch2, ch3, ch4), byrow = TRUE, ncol = 2)

## Plot the second row
plot(chrs[2, , drop = FALSE])

## Plot all chromatograms
plot(chrs, col = c("#ff000080", "#00ff0080"))
}
\seealso{
\code{\link{Chromatogram}} for the class representing chromatogram
    data.
    \code{\link{chromatogram}} for the method to extract a
    \code{Chromatograms} object from a \code{\linkS4class{MSnExp}} or
    \code{\linkS4class{OnDiskMSnExp}} object.
    \code{\link{readSRMData}} for the function to read chromatographic data
    of an SRM/MRM experiment.
}
\author{
Johannes Rainer
}
